UNIT UI_BINI_Convert;
{$mode objfpc}{$H+}
INTERFACE
USES
    Classes
  , Sysutils
  , Forms
  , Controls
  , Graphics
  , Dialogs
  , StdCtrls
  , process
  , UCA_BINI_Descriptor
  ;


TYPE

  { Tform1 }

  Tform1 = CLASS ( Tform)
    Button1 : Tbutton;
    Button2 : Tbutton;
    Memo1 : Tmemo;
    PROCEDURE Button1click( Sender : Tobject) ;
    PROCEDURE Button2click( Sender : Tobject) ;
    PROCEDURE Formcreate( Sender : Tobject) ;
    PROCEDURE Formdestroy( Sender : Tobject) ;
  Private
  Public

  END ;

CONST
  _FileName = 'shiparch.Bini';


VAR
  Form1 : Tform1;

IMPLEMENTATION
{$R *.lfm}

{ Tform1 }

PROCEDURE Tform1.Formcreate( Sender : Tobject) ;
BEGIN
  EXIT;
End;

PROCEDURE Tform1.Formdestroy( Sender : Tobject) ;
BEGIN
  IF Assigned( go_FileStream ) THEN
    FreeAndNil( go_FileStream );
End;


PROCEDURE Tform1.Button1click( Sender : Tobject) ;
BEGIN
  Decrypt_BINI( _FileName );
End;


{ Echt coole Idee von Theo }
PROCEDURE Tform1.Button2click( Sender : Tobject) ;
const
  BUF_SIZE = 2048;
var
  AProcess: TProcess;
  OutputStream: TStream;
  BytesRead: longint;
  Buffer: array[1..BUF_SIZE] of byte;
BEGIN
  AProcess := TProcess.Create(nil);
//  AProcess.Executable := '/home/theo/Install/binitools-master/unbini';
//  AProcess.Parameters.Add('/home/theo/Install/binitools-master/test.bini');

  AProcess.Executable := 'UnBini';
  AProcess.Parameters.Add('shiparch.Bini');
  AProcess.Options := [poUsePipes];
  AProcess.Execute;
  OutputStream := TMemoryStream.Create;
  repeat
    BytesRead := AProcess.Output.Read(Buffer, BUF_SIZE);
    OutputStream.Write(Buffer, BytesRead)
  until BytesRead = 0;
  AProcess.Free;
  OutputStream.Position := 0;
  Memo1.Lines.LoadFromStream(OutputStream);
  OutputStream.Free;
End;




END .

